% Generate Match and Calculate Moments
function mom=gen_moms(X,Z,qty,epsilon,eta)

    u=repmat(X,1,size(epsilon,2))+epsilon;
    v=repmat(Z,1,size(eta,2))+eta;
    
    % Sort the lists, this gives the matches
    [~,Iu]=sort(u,1);
    [~,Iv]=sort(v,1);
    
    mom=zeros(2,size(eta,2));
    
    parfor bb=1:size(epsilon,2)
        Iv_out=match_em(Iv(:,bb),qty);
        XZ=X(Iu(:,bb)).*Z(Iv_out);
        mom(:,bb)=[mean(XZ);within_mom(X(Iu(:,bb)),Iv(:,bb),qty)];        
    end
    
    mean(mom,2);
end

% Replicate
function Iv_out=match_em(Iv,qty)
    Iv_out=zeros(sum(qty),1);
    Iv_out(1:qty(1))=Iv(1);
    for jj=2:size(Iv,1)       
        Iv_out(sum(qty(1:jj-1))+1:sum(qty(1:jj)))=Iv(jj);
    end
end

% Within Moments
function within_mom=within_mom(X,Iv,qty)
    within_mom=zeros(size(qty));
    within_mom(1)=std(X(1:qty(1)))*qty(1);
    for jj=2:size(Iv,1)       
        within_mom(jj)=std(X(sum(qty(1:jj-1))+1:sum(qty(1:jj))))*qty(jj);
    end
    within_mom=sum(within_mom)/sum(qty);
end
