matlabpool close force;
matlabpool open local 8;

% Set the parameters of the problem

J=500;
q_bar=10;

rng(1);

% Generate Capacity
qty=ceil(rand(J,1)*q_bar);
N=sum(qty);

% Draw Observables
X=mvnrnd(0,1,N);
Z=mvnrnd(0,1,J);

% Draw Unobservables
epsilon=mvnrnd(0,1,N);
eta=mvnrnd(0,1,J);

mom_dat=gen_moms(X,Z,qty,epsilon,eta);


% Simulated Stuff
B=2500;
epsilon=mvnrnd(zeros(1,B),eye(B),N);
eta=mvnrnd(zeros(1,B),eye(B),J);


% Create a grid
Gsize=25;
gridb=linspace(0.5,1.5,Gsize);
gridg=linspace(0.5,1.5,Gsize);

obj_ov=zeros(Gsize);
obj_w=zeros(Gsize);

for ii=1:Gsize
ii
   for jj=1:Gsize
        mom=gen_moms(X*gridb(ii),Z*gridg(jj),qty,epsilon,eta);
        obj_ov(ii,jj)=(mom(1)-mom_dat(1))^2;
        obj_w(ii,jj)=(mom(2)-mom_dat(2))^2;
   end   
end

save many_to_one_coarse;

matlabpool close force;
exit;
