

% Variable names
X_names={'Xvar1','Xvar2','Xvar3'};
Z_names={'Zvar1','Zvar2','Zvar3','Zvar4'};

% Size of dataset
J_mat=[100,500];
qty_mat=[5 10];

% Specification selection
u_X_mat={{'Xvar1'},{'Xvar1','Xvar2'}};
v_Z_mat={{'Zvar1'},{'Zvar1','Zvar2'}};
v_XZ_mat={{'Xvar3*Zvar1'},{'Xvar3*Zvar1','Xvar3*Zvar3'}};
v_rc_mat={{'const';'Zvar1'},{'const','const';'Zvar1','Zvar4'}};

% Co-efficient selection
beta_mat=[1 1;0 2];
gamma_mat=[1 -1;0 2];
gamma_int_mat=[1 -1;0 2];
gamma_rc_mat=[0 0;NaN 1];

mom_spec_w_mat={{'Xvar1';'Xvar1';'const';'const'},{'Xvar1','Xvar1','Xvar2';'Xvar1','Xvar2','Xvar2';'const','const','const';'const','const','const'}};
mom_spec_ov_v_mat={{'Xvar1','Xvar1','Xvar1^2';'Zvar1','Zvar1^2','Zvar1'},...
		   {'Xvar1','Xvar1','Xvar1^2','Xvar2','Xvar2','Xvar2^2','Xvar1','Xvar1','Xvar1^2','Xvar2','Xvar2','Xvar2^2','Xvar1*Xvar2','Xvar1*Xvar2','Xvar1','Xvar2';...
		    'Zvar1','Zvar1^2','Zvar1','Zvar1','Zvar1^2','Zvar1','Zvar2','Zvar2^2','Zvar2','Zvar2','Zvar2^2','Zvar2','Zvar1','Zvar2','Zvar1*Zvar2','Zvar1*Zvar2'}};
mom_spec_ov_h_mat={{'Xvar3','Xvar3','Xvar3^2','Xvar1*Xvar3';'Zvar1','Zvar1^2','Zvar1','Zvar1'},...
    {'Xvar3','Xvar3','Xvar3','Xvar1','Xvar2','Xvar3*Xvar1','Xvar3*Xvar2','Xvar3^2','Xvar3*Xvar1','Xvar3*Xvar2','Xvar3^2','Xvar3*Xvar1','Xvar3*Xvar2','Xvar3^2',...
     'Xvar1'      ,'Xvar1'      ,'Xvar1'      ,'Xvar2'      ,'Xvar2'      ,'Xvar2'      ,'Xvar3'      ,'Xvar3'      ,'Xvar3';
     'Zvar1','Zvar2','Zvar3','Zvar3','Zvar3','Zvar1'      ,'Zvar1'      ,'Zvar1'      ,'Zvar2'      ,'Zvar2'      ,'Zvar2'      ,'Zvar3'      ,'Zvar3'      ,'Zvar3',...
     'Zvar3*Zvar1','Zvar3*Zvar2','Zvar3^2','Zvar3*Zvar1','Zvar3*Zvar2','Zvar3^2','Zvar3*Zvar1','Zvar3*Zvar2','Zvar3^2'}};
     
mom_spec_ov_rc_mat={{},{'Xvar1','Xvar2','Xvar3','Xvar1'  ,'Xvar2'  ,'Xvar3'  ,'Xvar1'      ,'Xvar2'      ,'Xvar3'      ,'Xvar1'      ,'Xvar2'      ,'Xvar3'      ,'Xvar1'      ,'Xvar2'      ,'Xvar3'    ,...
   'Xvar1^2','Xvar1*Xvar2','Xvar1*Xvar3','Xvar2^2','Xvar2*Xvar3','Xvar3^2';
  'Zvar4','Zvar4','Zvar4','Zvar4^2','Zvar4^2','Zvar4^2','Zvar4*Zvar1','Zvar4*Zvar1','Zvar4*Zvar1','Zvar4*Zvar2','Zvar4*Zvar2','Zvar4*Zvar2','Zvar4*Zvar3','Zvar4*Zvar3','Zvar4*Zvar3',...
   'Zvar4','Zvar4',        'Zvar4',      'Zvar4',  'Zvar4'      ,  'Zvar4'}};

for jj=1:size(J_mat,2)
  mc.J=J_mat(jj);
  for qq=1:size(qty_mat,2)
    mc.q_bar=qty_mat(qq);
    for mm=1:3  % Indexes model type, v-v, v-h and v-rc
      for cc=1:2 % Complexity -> One variable or two
        % The specification of the model
        model.u_X=u_X_mat{cc};
        model.v_Z=v_Z_mat{cc};
        model.v_XZ=v_XZ_mat{cc};
        model.v_rc=v_rc_mat{cc};
        model.normalize={'Xvar1'};

        % Co-efficients
       	mc.beta=beta_mat(1:cc,cc);
        mc.gamma=gamma_mat(1:cc,cc);
        mc.gamma_int=gamma_int_mat(1:cc,cc);
        mc.gamma_rc=gamma_rc_mat(1:cc,cc);

        % Moments
        mom_specs.mom_w_spec=mom_spec_w_mat{cc};
        
        if mm==1
            model.v_XZ={};
            model.v_rc=[];
            mc.gamma_int=[];
            mc.gamma_rc=[];
            mom_specs.mom_ov_spec=mom_spec_ov_v_mat{cc};
        end
        if mm==2
            model.v_rc={};
            mc.gamma_rc=[];
            mom_specs.mom_ov_spec=[mom_spec_ov_v_mat{cc} mom_spec_ov_h_mat{cc}];
        end
        if mm==3
            mom_specs.mom_ov_spec=[mom_spec_ov_v_mat{cc} mom_spec_ov_h_mat{cc} mom_spec_ov_rc_mat{cc}];
        end
    
        mom_specs.mom_peer_spec={};
        mom_specs.mom_xz_spec={};

        mc.theta_0=[mc.beta;mc.gamma;mc.gamma_int;mc.gamma_rc;0;0];
        filenm=['mc_results/mc_spec_J' num2str(mc.J) 'Q' num2str(mc.q_bar) 'M' num2str(mm) 'V' num2str(cc) '.mat'];
        save(filenm,'mc','model','mom_specs');
      end
    end
  end
end
