%% Generate a Table with MC summary

J_mat=[100 500];
Q_mat=[5 10];

theta_mat=zeros(8,24,9);
model_name=cell(24,1);



counter=0;
for mm=1:3
    for vv=1:2
        for jj=1:2
            for qq=1:2
                counter=counter+1;
                
                % Write model_name
                model_name{counter}=['J' num2str(J_mat(jj)) 'Q' num2str(Q_mat(qq)) 'M' num2str(mm) 'V' num2str(vv)];
                
                filenm=['mc_result_allJ' num2str(J_mat(jj)) 'Q' num2str(Q_mat(qq)) 'M' num2str(mm) 'V' num2str(vv)];
                load(filenm);
                
                %%% Which thetas to pull out
                loc=true(8,1);
                if mm==1
                   loc(5:end)=false;               
                end
                if mm==2
                   loc(7:end)=false;                   
                end
                if vv==1
                   loc(2:2:8)=false;
                end
                
                %%% Add the theta
                theta_locs=true(size(mc.theta_0));
                theta_locs(end-1:end)=false;
                % True
                theta_mat(loc,counter,1)=mc.theta_0(theta_locs);
                % Mean est
                theta_mat(loc,counter,2)=mean(theta(theta_locs,:),2);
                % Bias
                theta_mat(loc,counter,3)=theta_mat(loc,counter,2)-theta_mat(loc,counter,1);
                % RMSE
                theta_mat(loc,counter,4)=sqrt(mean((theta(theta_locs,:)-repmat(mc.theta_0(theta_locs),1,500)).^2,2));
                % Mean se avar and boot
                theta_mat(loc,counter,5)=mean(se.avar(theta_locs,:),2);
                theta_mat(loc,counter,6)=mean(se.boot(theta_locs,:),2);
                
                % Coverage
                theta_mat(loc,counter,7)=mean(cover.avar(theta_locs,:),2);
                theta_mat(loc,counter,8)=mean(cover.boot(theta_locs,:),2);
                theta_mat(loc,counter,9)=mean(cover.boot_cut(theta_locs,:),2);
                               
            end
        end
    end
end

ds=dataset({cat(1,strcat('beta',{'_1';'_2'}),strcat('gamma',{'_1';'_2'}),strcat('gamma_int',{'_1';'_2'}),strcat('gamma_rc',{'_1';'_2'})),'Coeff'});
for ii=1:counter
    varnames=strcat(model_name(ii),{'_true','_est','_bias','_rmse','_se_av','_se_bt','_cov_av','_cov_bt','_cov_bc'});
    ds=cat(2,ds,dataset({reshape(theta_mat(:,ii,:),8,9),varnames{:}}));    
end

export(ds,'file','MC_output.csv','Delimiter',',');