spec_name=['J' num2str(jj) 'Q' num2str(qq) 'M' num2str(mm) 'V' num2str(vv)];
clear jj qq mm vv;

disp(spec_name);
load(['mc_results/mc_spec_' spec_name '.mat']);

boot_set.boot_est=false; % Changes to true if you want bootstrapped
boot_set.boot_est_iter=500;

theta_mc=zeros(size(mc.theta_0,1),B);
theta_local=zeros(size(mc.theta_0,1),B);
cover_mc_boot_cut=theta_mc;
cover_mc_boot=theta_mc;
cover_mc_avar=theta_mc;
boot_ci_low=theta_mc;
boot_ci_high=theta_mc;
se_mc_boot=theta_mc;
se_mc_avar=theta_mc;
time_est=zeros(1,B);
time_boot=time_est;

for bb=1:B
    disp(['Monte Carlo Iteration: ' num2str(bb+B_low)]);

    output=monte_carlo(bb+B_low,model,mc,mom_specs,boot_set);
    output.theta_local_2_se=[output.theta_local_2_se;0;0];  % The se for constrained coefficients need to be added
                                                            
    theta_local(:,bb)=output.theta_local;
    theta_mc(:,bb)=output.theta_local_2;
    se_mc_avar(:,bb)=output.theta_local_2_se;
    se_mc_boot(:,bb)=output.theta_local_2_boot_se;
    cover_mc_avar(:,bb)=abs((output.theta_local_2-mc.theta_0)./output.theta_local_2_se)<=1.96;
    cover_mc_boot(:,bb)=abs((output.theta_local_2-mc.theta_0)./output.theta_local_2_boot_se)<=1.96;
    cover_mc_boot_cut(:,bb)=all([output.theta_local_2_ci(:,1)<=mc.theta_0 output.theta_local_2_ci(:,2)>=mc.theta_0],2);
    boot_ci_low(:,bb)=output.theta_local_2_ci(:,1);
    boot_ci_high(:,bb)=output.theta_local_2_ci(:,2);

    time_est(bb)=output.time_local_2+output.time_local+output.time_se_local;
    if isfield(output,'time_boot')
        time_boot(bb)=output.time_boot;
    end

    save(['mc_results/mc_result_' spec_name '_' num2str(B_low+1) '_' num2str(B_low+B)]);
end

