#include <mex.h>

void calc_rc_match(double *match, double *u,double *v_det, double *beta_i_sim, double *Z_rc, double *eta_sim, double *qty,int N, int J, int K_rc)
{
    int *avail_hosp;
    int J_avail,max_loc,who_picks;
    int i,j;
    double *qty_avail;
          
    /* Allocate Memory */
    avail_hosp=mxCalloc(N,sizeof(int));
    qty_avail=mxCalloc(J,sizeof(double));
         
    /* Initialize the available doctors and hospitals */
    for(j=0;j<J;j++)
        avail_hosp[j]=j;
   
    /* Initialize qty avail to qty */
    J_avail=J;
    for(j=0;j<J;j++)
        qty_avail[j]=qty[j];    

    /* Sort the doctors */
    sort_u_Array(match,u,N);
        
    for(i=0;i<N;i++)
    {
        max_loc=max_v_rc_Array(v_det,Z_rc,beta_i_sim,avail_hosp,J_avail,(int) match[i],eta_sim,N,J,K_rc);
        match[N+i]=avail_hosp[max_loc];                  
        
        /* Decrease the quantity by one at the chosen hospital */
        qty_avail[(int) avail_hosp[max_loc]]--;
        
        if(qty_avail[(int) avail_hosp[max_loc]]==0)
        {
            /* Decrease the number of hospitals available */
            J_avail--;
            /* Change the availability set of hospitals */
            for(j=max_loc;j<J_avail;j++)
                avail_hosp[j]=avail_hosp[j+1];            
          
        }
        
    }

    /* Free up memory */
    mxFree(avail_hosp);
    mxFree(qty_avail);
}
