/* Takes a match, matrix of Xs, matrix of Zs, two sets of moment specifications (one within
 * and one overall) to compute moments, and if necessary, moment covariances */

#include <mex.h>

/* Function call [moments, mom_cov]=match_moms_c.c(match,N,J,X,Z,XZ,mom_ov,mom_xz,mom_w,mom_peer) */

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
  int N,J,i,mom_ov_K,mom_w_K,mom_xz_K,mom_peer_K;
    double *match,*match_data, *moments, *mom_covar,*X,*Z,*XZ, *mom_ov, *mom_w, *mom_xz, *mom_peer, *ptr;

    /* Get all the pointers */
    match_data=mxGetPr(prhs[0]);
    
    ptr=mxGetPr(prhs[1]);
    N=(int) ptr[0];

    ptr=mxGetPr(prhs[2]);
    J=(int) ptr[0];

    if(nrhs<10)
      mexErrMsgTxt("Err: Not enough input arguments to mex File.");

    /* Storage for the match should be different from the inputs */
    match=mxCalloc(N*2,sizeof(double));

    X=mxGetPr(prhs[3]);
    Z=mxGetPr(prhs[4]);
    XZ=mxGetPr(prhs[5]);
    
    mom_ov=mxGetPr(prhs[6]);
    mom_xz=mxGetPr(prhs[7]);
    mom_w=mxGetPr(prhs[8]);
    mom_peer=mxGetPr(prhs[9]);

    mom_ov_K=mxGetN(prhs[6]);
    mom_xz_K=mxGetN(prhs[7]);
    mom_w_K=mxGetN(prhs[8]);
    mom_peer_K=mxGetN(prhs[9]);

    /* Convert the match to C indices */
    for(i=0;i<N;i++)
    {
        match[i]=match_data[i]-1;
	match[N+i]=match_data[N+i]-1;
    }
    
    /* Create a pointer to the outputs */
    plhs[0]=mxCreateDoubleMatrix(mom_ov_K+mom_xz_K+mom_w_K+mom_peer_K,1,mxREAL);
    moments=mxGetPr(plhs[0]);
    calc_mom(match,X,Z,XZ,N,J,mom_ov,mom_ov_K,mom_xz,mom_xz_K,mom_w,mom_w_K,mom_peer,mom_peer_K,moments);

}
