function [moments_boot,str_data_boot,mom_data_boot]= rc_boot_bb_market(bb,str_data,mom_data,theta_str,K,u_det,v_det)
       rng(bb);
       
       % Sample the hospitals
       sample_J=ceil(rand(str_data.J,1)*str_data.J);
       str_data_boot.qty=str_data.qty(sample_J);
       str_data_boot.J=str_data.J;
       str_data_boot.Z_rc=str_data.Z_rc(sample_J,:);
        
       % Sample the doctors
       str_data_boot.N=binornd(sum(str_data_boot.qty),str_data.p);       
       sample_N=ceil(rand(str_data_boot.N,1)*str_data.N);
       str_data_boot.X_het=str_data.X_het(sample_N,:);
       str_data_boot.X_rc=str_data.X_rc(sample_N,:);
       
       % Sample unobservables
       sim_data=gen_sims(str_data_boot.N,str_data_boot.J,1,K.rc);
              
       % Get utils       
       [sim_data.e,sim_data.eta,sim_data.nu_i]=sim_data_theta(sim_data,theta_str,str_data_boot);
              
       v_det_boot=v_det(sample_J,sample_N);
       u_boot=u_det(sample_N)+sim_data.e;

       % Calculate the moment
       mom_data_boot.X_moms=mom_data.X_moms(sample_N,:);
       mom_data_boot.Z_moms=mom_data.Z_moms(sample_J,:);  
       mom_data_boot.mom_w=mom_data.mom_w;
       mom_data_boot.mom_ov=mom_data.mom_ov;
       mom_data_boot.mom_peer=mom_data.mom_peer;
       
       % Calculate the indices
       indices=repmat(sample_J,str_data_boot.N,1)+reshape(repmat(sample_N'-1,str_data.J,1)*str_data.J,str_data_boot.N*str_data.J,1);
       mom_data_boot.XZ_moms=mom_data.XZ_moms(indices,:);
       mom_data_boot.mom_xz=mom_data.mom_xz;
       
       [~,moments_boot]=rc_moms_c(u_boot,v_det_boot,sim_data.eta,sim_data.nu_i,str_data_boot.Z_rc,str_data_boot.qty,mom_data_boot.X_moms,mom_data_boot.Z_moms,mom_data_boot.XZ_moms,mom_data_boot.mom_ov,mom_data_boot.mom_xz,mom_data_boot.mom_w,mom_data_boot.mom_peer);
       
       % Provide the other structural pieces if desired
       if nargout>1
           str_data_boot.X_str=str_data.X_str(sample_N,:);
           str_data_boot.Z_str=str_data.Z_str(sample_J,:);

           % XZ_str is needed only if it's not empty 
           if ~isempty(str_data.XZ_str)               
               str_data_boot.XZ_str=str_data.XZ_str(indices,:);
           else
               str_data_boot.XZ_str=str_data.XZ_str;
           end
           
           mom_data_boot.moments=moments_boot;
       end

end