function [theta_boot,exitflag_boot,obj_boot]=rc_boot_est(B,sims,theta,opt,str_data,K,mom_data,W)
                    
    if isrow(theta)
        theta=theta';
    end
    
    theta_str=split_theta(theta,K);  
       
    % Fix opt
    opt.verbose=0;
    
    % Compute the deterministic pieces for the
    [u_det,v_det]=det_util(str_data,theta_str);          

    % Pre-allocate boot-strap memory
    theta_boot=zeros(size(theta,1),B);
    exitflag_boot=zeros(B,1);
    obj_boot=zeros(B,1);
           
    parfor bb=1:B
        disp(['Bootstrapping: ' num2str(bb)]);
        [theta_boot(:,bb),exitflag_boot(bb),obj_boot(bb)]=rc_boot_est_bb(theta,K,bb,sims,u_det,v_det,mom_data,str_data,W,opt);
    end             
                    
end

function [theta_boot,exitflag_boot,obj_boot]=rc_boot_est_bb(theta_hat,K,bb,sims,u_det,v_det,mom_data,str_data,W,opt)
       
       theta_str=split_theta(theta_hat,K);  

       % Draw a market
       [~,str_data_boot,mom_data_boot]= rc_boot_bb_market(bb,str_data,mom_data,theta_str,K,u_det,v_det);

       sim_boot=gen_sims(str_data_boot.N,str_data_boot.J,sims,K.rc);
              
       % The objective function
       opt.min_objective=@(theta) rc_msm_obj(theta,str_data_boot,sim_boot,K,mom_data_boot,W);
       clear *boot;       
       [theta_boot,exitflag_boot,obj_boot]=nlopt_optimize(opt,theta_hat);
end