function [mean_mom,var_sim]=rc_msm_mom(theta,str_data,sim_data,K,mom_data)

    if isrow(theta)
        theta=theta';
    end
    
    theta_str=split_theta(theta,K);  
    
    % Compute the error pieces
    [e,eta,nu_i]=sim_data_theta(sim_data,theta_str,str_data);
        
    % Compute the deterministic pieces for the moments
    [u_det,v_det]=det_util(str_data,theta_str);
    
    % Initialize
    mom_sim=zeros(size(mom_data.mom_ov,2)+size(mom_data.mom_w,2)+size(mom_data.mom_xz,2)+size(mom_data.mom_peer,2),sim_data.sims);
    
    % Splice variables
    Z_rc=str_data.Z_rc;
    X_moms=mom_data.X_moms;
    Z_moms=mom_data.Z_moms;    
    XZ_moms=mom_data.XZ_moms;    
    qty=str_data.qty;
    
    mom_w=mom_data.mom_w;
    mom_xz=mom_data.mom_xz;
    mom_ov=mom_data.mom_ov;
    mom_peer=mom_data.mom_peer;
    
    parfor ii=1:sim_data.sims
        [~,mom_sim(:,ii)]=rc_moms_c(u_det+e(:,ii),v_det,eta(:,ii),nu_i(:,:,ii),Z_rc,qty,X_moms,Z_moms,XZ_moms,mom_ov,mom_xz,mom_w,mom_peer);        
    end 
        
    mean_mom=mean(mom_sim,2);
    
    if nargout>1
       var_sim=cov(mom_sim'); 
    end
end