function sim_out=rc_msm_sim(theta,str_data,sim_data,K,mom_data)

    if isrow(theta)
        theta=theta';
    end
    
    theta_str=split_theta(theta,K);  
    
    % Compute the error pieces
    [sim_out.e,sim_out.eta,sim_out.nu_i]=sim_data_theta(sim_data,theta_str,str_data);
        
    % Compute the deterministic pieces for the moments
    [sim_out.u_det,sim_out.v_det]=det_util(str_data,theta_str);
    
    % Initialize
    match=zeros(str_data.N,2,sim_data.sims);
    
    % Splica the variables
    Z_rc=str_data.Z_rc;
    qty=str_data.qty;
    
    if nargin>4
        X_moms=mom_data.X_moms;
        Z_moms=mom_data.Z_moms;    
        XZ_moms=mom_data.XZ_moms;    
        
        mom_w=mom_data.mom_w;
        mom_xz=mom_data.mom_xz;
        mom_ov=mom_data.mom_ov;
        mom_peer=mom_data.mom_peer;
    end

    sim_out.u=repmat(sim_out.u_det,1,size(sim_out.e,2))+sim_out.e;

    % Pre-allocate
    sim_out.match=zeros(str_data.N,2,size(sim_out.u,2));
    if nargin>4
        sim_out.mom_sim=zeros(size(mom_data.moments,1),size(sim_out.u,2));
        sim_out.sim_wt=zeros(1,size(sim_out.u,2));
    end
    sim_out.u_match=zeros(size(sim_out.u));
    sim_out.v_det_match=zeros(size(sim_out.u));
    sim_out.v_eta_match=zeros(size(sim_out.u));
    sim_out.v_match=zeros(size(sim_out.u));
   
    for ii=1:sim_data.sims
        if nargin>4
            [sim_out.match(:,:,ii),sim_out.mom_sim(:,ii)]=rc_moms_c(sim_out.u(:,ii),sim_out.v_det,sim_out.eta(:,ii),sim_out.nu_i(:,:,ii),Z_rc,qty,X_moms,Z_moms,XZ_moms,mom_ov,mom_xz,mom_w,mom_peer);
        else
            sim_out.match(:,:,ii)=rc_moms_c(sim_out.u(:,ii),sim_out.v_det,sim_out.eta(:,ii),sim_out.nu_i(:,:,ii),Z_rc,qty);
        end       
        % Compute and store the utilities to the matched entity
        sim_out.u_match(:,ii)=sim_out.u(sim_out.match(:,1,ii),ii);
        sim_out.v_det_match(:,ii)=sim_out.v_det(sub2ind([str_data.J str_data.N],sim_out.match(:,2,ii),sim_out.match(:,1,ii)));
        sim_out.v_eta_match(:,ii)=sim_out.v_det_match(:,ii)+sim_out.eta(sim_out.match(:,2,ii),ii);
        sim_out.v_match(:,ii)=sim_out.v_eta_match(:,ii)+sum(sim_out.nu_i(sim_out.match(:,1,ii),:,ii).*Z_rc(sim_out.match(:,2,ii),:),2);
    end 
    
    if nargin>4
        mean_mom=mean(sim_out.mom_sim,2);
        inv_mom_var=inv(cov(sim_out.mom_sim'));
        
        for ii=1:sim_data.sims
              sim_out.sim_wt(ii)=exp(-0.5*(sim_out.mom_sim(:,ii)-mean_mom)'*inv_mom_var*(sim_out.mom_sim(:,ii)-mean_mom)); 
        end   
        sim_out.sim_wt=sim_out.sim_wt/sum(sim_out.sim_wt);
    end

end